package com.findme;

import java.util.ArrayList;
import java.util.Date;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.app.Application;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SHA;
import com.findme.utils.SoapCall;

public class FindMeApp extends Application {

    private String sessionId;
    private User super_user;
    private ArrayList<User> friends;

    public User getUsuario() {
        return super_user;
    }

    public void setUsuario(User usuario) {
        this.super_user = usuario;
    }

	public void setSessionId(String sessionId) {
		this.sessionId = sessionId;
	}

	public String getSessionId() {
		return sessionId;
	}

	public void setFriends(ArrayList<User> friends) {
		this.friends = friends;
	}

	public ArrayList<User> getFriends() {
		return friends;
	}
	
	public void reloadFriends() {
		//Recuperem les amistats
		ArrayList<User> friendUser = new ArrayList<User>();
		try {
			boolean profile;
			JSONObject json = null;
			String[][] matriz={{"session_id", this.getSessionId()}};
			json = SoapCall.requestJson("getFriends", matriz);
			if(json.getString("success") != null) {
				if(json.get("friends") instanceof JSONArray) {
		    		JSONArray friends = json.getJSONArray("friends");
		    		for (int i = 0; i < friends.length(); i++) {
		    			//Como cada elemento del array está en JSON, obtenemos el objeto JSON correspondiente
		    			JSONObject d = friends.getJSONObject(i);
		    			profile = false;
                    	if(d.getString("profile").equals("1")) {
                    		profile = true;
                    	}
		    			//Obtenemos los datos del susodicho
		    			friendUser.add(new User(d.getInt("Id"),d.getString("name"),d.getString("email"), "", 
		    					d.getInt("longitud"),d.getInt("latitud"),new Date(),true, profile, false));
		    		}
		    	}
			}
			this.setFriends(friendUser);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void saveCurrentLocation(String longitud, String latitud) {
		try {
			String[][] matriz={{"session_id", this.getSessionId()},{"longitud", longitud},{"latitud", latitud}};
			SoapCall.requestJson("updateLocation", matriz);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public boolean updateUser(String nom, String profile, String newP) {
		JSONObject json = null;
		try {
			if(!newP.equals("")) {
				String[][] matriz={{"session_id", this.getSessionId()},{"name", nom},{"profile", profile},{"password", SHA.hexDigest(newP)}};
				json = SoapCall.requestJson("updateUser", matriz);
			} else {
				String[][] matriz={{"session_id", this.getSessionId()},{"name", nom},{"profile", profile}};
				json = SoapCall.requestJson("updateUser", matriz);
			}
			if(json.getString("success") != null) {
				super_user.setName(nom);
				if(profile.equals("0")) {
					super_user.setProfile(false);
				} else { 
					super_user.setProfile(true);
				}
				if(!newP.equals("")) {
					super_user.setPassword(SHA.hexDigest(newP));
				}
				return true;
			}
		} catch (JSONException e) {
			try {
				Alerta.alerta(this,String.valueOf(json.getString("error")));
				return false;
			} catch (JSONException e1) {
				return false;
			}
		} catch (Exception e) {
			return false;
		}
		
		
		
		return false;
	}
	
	/*public boolean viewNotification() {
		try {
			JSONObject json = null;
			String[][] matriz={{"session_id", this.getSessionId()}};
			json = SoapCall.requestJson("viewNotification", matriz);
			if(json.getString("notifications") != null) {
				if(json.get("notifications") instanceof JSONArray) {
		    		JSONArray friends = json.getJSONArray("notifications");
		    		for (int i = 0; i < friends.length(); i++) {
		    			JSONObject d = friends.getJSONObject(i);
		    			
		    		}
		    	}
			}
			this.setNotification(notification);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}*/
}
