package com.findme;

import java.util.ArrayList;

import android.app.ListActivity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import com.findme.beans.User;
import com.findme.utils.Alerta;

public class FriendsList extends FindMeListActivity {
	private static final String LOGTAG = "FindMe-FriendsListView";
	
	private ArrayList<User> usuarios;
	private int iUserSelected = 1; // Por defecto
	private boolean search = false;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
		
		
		Bundle extras = getIntent().getExtras();
		if(extras != null) {
			usuarios = (ArrayList<User>) extras.get("search");
			search = true;
		} else {
			((FindMeApp) this.getApplication()).reloadFriends();
			usuarios = ((FindMeApp) this.getApplication()).getFriends();
		}
		
		if (usuarios != null){
			ArrayAdapter<String> aAdapter=new ArrayAdapter<String>(this, R.layout.list_item, getFriends());
	        setListAdapter(aAdapter);
			
	        ListView lv = getListView();
	        lv.setTextFilterEnabled(true);
	        lv.setOnItemClickListener(new OnItemClickListener() {
	        	public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
	        		iUserSelected = position;
	        		carregaUsuari(usuarios.get(iUserSelected));
	        	}
	        });
		}
	}
	
	protected void carregaUsuari(User usuari) {
    	Alerta.toast(this, "Searching for "+usuari.getName());
    	Intent i = new Intent(this, HomeMapActivity.class);
    	i.putExtra("usuari", usuari);
    	if(search) {
    		i.putExtra("search", true);
    	} else {
    		i.putExtra("search", false);
    	}
    	startActivity(i);
	}
	
	 //Funcion que recupera el nom dels usuaris en un ArrayList
    private ArrayList<String> getFriends(){
    	ArrayList<String> aListaTitulos = new ArrayList<String>();
    	
    	for (int i=0; i<usuarios.size(); i++){
    		aListaTitulos.add(usuarios.get(i).toString());
    	}
    	return aListaTitulos;
    }
	
	
}

