package com.findme;

import java.util.ArrayList;
import java.util.List;

import android.content.SharedPreferences;
import android.graphics.drawable.Drawable;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.preference.PreferenceManager;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SoapCall;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.google.android.maps.OverlayItem;


public class FriendsMapActivity extends FindMeMapActivity {
	
	private LocationManager lm;
    private LocationListener locationListener;

    private MapView mapView;
    private MapController mc;
    
    private ArrayList<User> usuarios;
    
    protected boolean isRouteDisplayed() {
	    return false;
	}
	
	public void onCreate(Bundle savedInstanceState) {
	    super.onCreate(savedInstanceState);
	    setContentView(R.layout.map);
	    
	    //Busquem la localització de l'usuari al mapa
	    Bundle extras = getIntent().getExtras();
	    User usuari = (User) extras.getSerializable("usuari");
	    boolean search = extras.getBoolean("search");
	    buscaPosicio(usuari, search);
	    
	}
	
	protected boolean guarda(String l1, String l2) {
		String[][] matriz={{"session_id", ((FindMeApp) this.getApplication()).getSessionId()},{"longitud", l1},{"latitud", l2}};
		try {
			SoapCall.requestJson("updateLocation", matriz);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
		}
		return false;
    }
	
	private void buscaPosicio(User usuari, boolean search) {
		int idUser = usuari.getId();
	    String name = usuari.getName();
        String email = usuari.getEmail() + " Last seen:"+usuari.getLastSeen();
        int latitud = Integer.valueOf(usuari.getLatitud());
        int longitud = Integer.valueOf(usuari.getLongitud());
        
        MapView mapView = (MapView) findViewById(R.id.mapview);
        mapView.setBuiltInZoomControls(true); 
        
        List<Overlay> mapOverlays = mapView.getOverlays();
        Drawable drawable;
        if(usuari.isFriend()) {
        	drawable = this.getResources().getDrawable(R.drawable.pin2);
        } else {
        	drawable = this.getResources().getDrawable(R.drawable.pin);
        }
        
		GeoPoint point = new GeoPoint(longitud,latitud);
        mapView.getController().animateTo(point);
        mapView.getController().setZoom(8);
        
        SharedPreferences _sharedPreferences  = PreferenceManager.getDefaultSharedPreferences(getBaseContext());
        String view = _sharedPreferences.getString("vista_mapa", "streetview");
        
        if (view.equals("streetview")) {
        	mapView.setStreetView(true);
        	mapView.setSatellite(false); 
        } else {
        	mapView.setStreetView(false);
        	mapView.setSatellite(true);
        }
        
        if(search) {
        	OverlayItem overlayitem = new OverlayItem(point, name, String.valueOf(idUser));
        	MyItemizedOverlay2 itemizedoverlay = new MyItemizedOverlay2(drawable, this);
        	itemizedoverlay.addOverlay(overlayitem);
        	mapOverlays.add(itemizedoverlay);
        } else {
        	OverlayItem overlayitem = new OverlayItem(point, name, email);
        	MyItemizedOverlay itemizedoverlay = new MyItemizedOverlay(drawable, this);
        	itemizedoverlay.addOverlay(overlayitem);
        	mapOverlays.add(itemizedoverlay);
        }
        
        //Carreguem els amics
        usuarios = ((FindMeApp) this.getApplication()).getFriends();
    	try {
    		if(usuarios.size() > 0) {
	    		User tmp = null;
		        for(int i=0;i<usuarios.size();i++) {         
		        	tmp = usuarios.get(i);
		            name = tmp.getName();
		            email = tmp.getEmail();
		            longitud = Integer.valueOf(tmp.getLongitud());
		            latitud = Integer.valueOf(tmp.getLatitud());
		        	point = new GeoPoint(longitud, latitud);
		        	OverlayItem overlayitem = new OverlayItem(point, name, email);
	            	drawable = this.getResources().getDrawable(R.drawable.pin2);
		        	MyItemizedOverlay itemizedoverlay = new MyItemizedOverlay(drawable, this);
		        	itemizedoverlay.addOverlay(overlayitem);
	                itemizedoverlay.addOverlay(new OverlayItem(point, name, email));
	                mapOverlays.add(itemizedoverlay);
		            i++;
		        }
    		} else {
    			Alerta.toast(this, "You don't have any friend yet");
    		}
        } catch (Exception e) { // Error
            
        }  
	}
}