package com.findme;

import java.io.IOException;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.xmlpull.v1.XmlPullParserException;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SoapCall;

public class FriendsSearch extends FindMeActivity {	
	private static User usuari = null;
	private static EditText name = null;
	private static EditText email = null;
	private static RadioButton radio1 = null;
	private static RadioButton radio2 = null;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);        
      setContentView(R.layout.friends_tab2);
      
      //Boto Search
      final Button save = (Button) findViewById(R.id.boto_save);
      save.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  EditText name = (EditText) findViewById(R.id.idFriendsSearchName);
        	  if(!name.toString().equals("")) {
        		  //Busquem
        		  try {
        			  Alerta.toast(getBaseContext(), "Searching ...");
        			  searchByName();
        		  } catch (Exception e) {
        			  e.printStackTrace();
        			  Alerta.toast(getBaseContext(), "Error Searching");
        		  }
        	  } else {
        		  Alerta.toast(getBaseContext(), "Please, enter something in name field");
        	  }
          }
      });
      
      name = (EditText) findViewById(R.id.idFriendsSearchName);
      email = (EditText) findViewById(R.id.idFriendsSearchEmail);
      email.setEnabled(false);
      //Radio Name
      radio1 = (RadioButton) findViewById(R.id.idFriendSearchRadioName);
      radio2 = (RadioButton) findViewById(R.id.idFriendSearchRadioEmail);
      radio1.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  radio1.setChecked(true);
        	  radio2.setChecked(false);
        	  email.setEnabled(false);
        	  name.setEnabled(true);
          }
      });
      radio2.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  radio1.setChecked(false);
        	  radio2.setChecked(true);
        	  name.setEnabled(false);
        	  email.setEnabled(true);
          }
      });
      
      //Boto Cancel
      /*final Button cancel = (Button) findViewById(R.id.boto_cancel);
      cancel.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
          	//Anem enrere
          	finish();
          }
      });*/      
    }

	protected void searchByName() throws IOException, XmlPullParserException, JSONException, ParseException {
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
		JSONObject json = null;
		String[][] matriz={{"session_id", ((FindMeApp) this.getApplication()).getSessionId()},{"name", name.getText().toString().trim()}};
		json = SoapCall.requestJson("searchByName", matriz);
		if(json.getString("success") != null) {
			//Recuperem els usuaris trobats
        	ArrayList<User> friendUser = new ArrayList<User>();
        	if(json.get("friends") instanceof JSONArray) {
        		JSONArray friends = json.getJSONArray("friends");
        		for (int i = 0; i < friends.length(); i++) {
        			//Como cada elemento del array está en JSON, obtenemos el objeto JSON correspondiente
        			JSONObject d = friends.getJSONObject(i);
        			//Obtenemos los datos del susodicho
        			friendUser.add(new User(d.getInt("Id"),d.getString("name"),d.getString("email"), "", d.getInt("longitud"),d.getInt("latitud"),new Date(),true, false, false));
        		}
        		//Enviem l'usuari a mostrar al mapa
            	Intent i = new Intent(this, FriendsList.class);
            	i.putExtra("search", friendUser);                	
            	startActivity(i);
        	}
        	
		} else {
			Alerta.toast(getBaseContext(), "Error getting list : "+json.getString("error"));
		}
	}
  }