package com.findme;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SHA;
import com.findme.utils.SoapCall;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.ksoap2.serialization.SoapObject;



public class LoginActivity extends Activity {

	TextView tv;

    private EditText mLogin;
    private EditText mPassword;
    private Button button;
    private Button button2;

	private String session_id;
    
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
                
        mLogin = (EditText) findViewById(R.id.text_name);
        mPassword = (EditText) findViewById(R.id.text_password);
        
        button = (Button) findViewById(R.id.boto_signin);
        button2 = (Button) findViewById(R.id.boto_signup);
        
        button.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	Alerta.toast(getBaseContext(), "Checking ...");
            	signIn();
            	button.setEnabled(false);
            	button2.setEnabled(true);
            }
        });
        
        
        button2.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
            	signUp();
            	button.setEnabled(true);
            	button2.setEnabled(false);
            }
        });
    }
    
    protected void signIn() {
    	String nom = mLogin.getText().toString();
    	String password = mPassword.getText().toString();
    	if(!nom.equals("") && !password.equals("")) {
    		//Autenticació
    		tv=(TextView)findViewById(R.id.text_resultat);
    		try {
    			String[][] matriz={  {"name", nom}, {"password", SHA.hexDigest(password)}};
    			SoapObject mainResult = SoapCall.request("login", matriz);
                Object result = (Object) mainResult.getProperty(0);
                
                //tv.setText(String.valueOf(result));
                
                if(String.valueOf(result).equals("1")) {
                	button2.setEnabled(false);
                	SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd");
                	
                	Alerta.toast(getBaseContext(), "Access granted : loading...");
                	
                	//Recuperem el IdSessio
                	this.session_id = (String) String.valueOf(mainResult.getProperty(1));
                	//tv.setText("Loading ... " + this.session_id);
                	((FindMeApp) this.getApplication()).setSessionId(this.session_id);
                	
                	//Recuperem les dades de l'usuari
                	JSONObject json = SoapCall.requestSession("getUserInfo", this.session_id); 
                	//Primer cop que entra
                	if(json.getString("last_seen") == null || json.getString("last_seen").equals("null")) {
                		//Actualitzem la posició de l'usuari
                    	((FindMeApp) this.getApplication()).saveCurrentLocation("41626502","0890644");
                    	//Recuperem de nou les dades de l'usuari
                    	json = SoapCall.requestSession("getUserInfo", this.session_id);
                	}
                	boolean profile = false;
                	if(json.getString("profile").equals("1")) {
                		profile = true;
                	}
                	boolean autolocation = false;
                	if(json.getString("autolocation").equals("1")) {
                		autolocation = true;
                	}
                	User usuari = new User(json.getInt("Id") ,json.getString("name"), json.getString("email"), SHA.hexDigest(password), json.getInt("longitud"), json.getInt("latitud"), new Date(), false, profile, autolocation);
                	//Recuperem les amistats
                	ArrayList<User> friendUser = new ArrayList<User>();
                	if(json.get("friends") instanceof JSONArray) {
                		JSONArray friends = json.getJSONArray("friends");
                		for (int i = 0; i < friends.length(); i++) {
                			//Como cada elemento del array está en JSON, obtenemos el objeto JSON correspondiente
                			JSONObject d = friends.getJSONObject(i);
                			profile = false;
                        	if(d.getString("profile").equals("1")) {
                        		profile = true;
                        	}
                			//Obtenemos los datos del susodicho
                			friendUser.add(new User(d.getInt("Id"),d.getString("name"),d.getString("email"), "", d.getInt("longitud"),d.getInt("latitud"),new Date(),true, profile, false));
                		}
                	}
                	
                	//Guardem variables "globals"
                	
                	((FindMeApp) this.getApplication()).setUsuario(usuari);
                	((FindMeApp) this.getApplication()).setFriends(friendUser);
                	
                	//Enviem l'usuari a mostrar al mapa
                	Intent i = new Intent(this, MapTab.class);
                	i.putExtra("usuari", usuari);                	
                	startActivity(i);
                    
                } else {
                	alertPlenaCamps(String.valueOf(mainResult.getProperty(1)));
                }


               
            } catch (Exception e) {
                tv.setText(e.getMessage());
            }
    	} else {
    		Alerta.alerta(this,"Fill both fields");
    	}
    }
    
    
    protected void signUp() {
    	String nom = mLogin.getText().toString();
    	String password = mPassword.getText().toString();
    	if(!nom.equals("") && !password.equals("")) {
    		//Autenticació
    		tv=(TextView)findViewById(R.id.text_resultat);
    			JSONObject json = null;
    			String[][] matriz={{"login", nom},{"password", SHA.hexDigest(password)}};
    			try {
    				json = SoapCall.requestJson("signUp", matriz);
					Alerta.toast(getBaseContext(), json.getString("success"));
				} catch (JSONException e) {
					try {
						Alerta.alerta(this,String.valueOf(json.getString("error")));
					} catch (JSONException e1) {
						tv.setText(e.getMessage());
					}
				} catch (Exception e) {
					tv.setText(e.getMessage());
				}
            
    	} else {
    		Alerta.alerta(this,"Fill both fields");
    	}
    }
    
    protected void alertPlenaCamps(String error) {
    	Alerta.alerta(this, error);
    	mPassword.setText("");
    }
    

}