package com.findme;

import java.io.IOException;
import java.util.ArrayList;

import org.json.JSONException;
import org.json.JSONObject;
import org.xmlpull.v1.XmlPullParserException;

import android.app.AlertDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.graphics.drawable.Drawable;

import com.findme.utils.Alerta;
import com.findme.utils.SoapCall;
import com.google.android.maps.ItemizedOverlay;
import com.google.android.maps.OverlayItem;

public class MyItemizedOverlay2 extends ItemizedOverlay {
	
	private ArrayList<OverlayItem> mOverlays = new ArrayList<OverlayItem>();
	Context mContext;
	OverlayItem item;
	
    public MyItemizedOverlay2(Drawable defaultMarker, Context context) { 
  
    	super(boundCenterBottom(defaultMarker));
    	mContext = context;
   	}
    
	@Override
	protected OverlayItem createItem(int i) {
		// TODO Auto-generated method stub
		return mOverlays.get(i);
	}

	public void addOverlay(OverlayItem overlay) {
	    mOverlays.add(overlay);
	    populate();
	}

    @Override
    protected boolean onTap(int index) {
    	
        item = mOverlays.get(index);
        
        AlertDialog.Builder builder = new AlertDialog.Builder(mContext);
		builder.setMessage("Do you want to add "+item.getTitle()+" as friend?")
		       .setCancelable(false)
		       .setPositiveButton("Yes", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		        	   Alerta.toast(mContext,"Adding user ...");
		        	   addFriend();
		           }
		       })
		       .setNegativeButton("No", new DialogInterface.OnClickListener() {
		           public void onClick(DialogInterface dialog, int id) {
		                dialog.cancel();
		           }
		       });
		AlertDialog alert = builder.create();
		alert.show();

        return false;
    }
	
	@Override
	public int size() {
		// TODO Auto-generated method stub
		return mOverlays.size();
	}
	
	public void addFriend() {
		String[][] matriz={{"session_id", ((FindMeApp) mContext.getApplicationContext()).getSessionId()},{"idUser", item.getSnippet()}};
		   JSONObject json;
		try {
			json = SoapCall.requestJson("addFriend", matriz);
			if(json.getString("success") != null) {
  			   Alerta.toast(mContext, "Friend added");
  			   ((FindMeApp) mContext.getApplicationContext()).reloadFriends();
			} else {
  			   Alerta.toast(mContext, json.getString("error"));
  		   	}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XmlPullParserException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			Alerta.toast(mContext, "Error adding friend");
		}
  		   
  	   	
	}

}