package com.findme;

import java.io.IOException;
import java.math.BigInteger;

import org.json.JSONException;
import org.json.JSONObject;
import org.xmlpull.v1.XmlPullParserException;

import android.content.Context;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;
import android.widget.TableLayout;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SoapCall;

public class OptionsLocation extends FindMeActivity {
	private static User usuari = null;
	private static EditText longitud = null;
	private static EditText latitud = null;
	private static RadioButton manual = null;
	private static RadioButton automatico = null;
	private static TableLayout table = null;
	
	private LocationManager locationManager;
	private LocationListener locationListener;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);        
      setContentView(R.layout.options_tab2);
      

      //Agafem les dades de l'usuari
      usuari = ((FindMeApp) this.getApplication()).getUsuario();
      
      //Plenem les dades de l'usuari
      longitud = (EditText) findViewById(R.id.idOptLongitud);
      longitud.setText(String.valueOf(usuari.getLongitud()));
      latitud = (EditText) findViewById(R.id.idOptLatitud);
      latitud.setText(String.valueOf(usuari.getLatitud()));
      
      manual = (RadioButton) findViewById(R.id.idOptRadioManual);
      automatico = (RadioButton) findViewById(R.id.idOptRadioAutomatic);
      table = (TableLayout) findViewById(R.id.idOptionsManual);
      
      //Boto Save
      final Button save = (Button) findViewById(R.id.boto_save);
      save.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  //Guardem
        	  try {
				if(guardaLocalitzacio()) {
					  //Actualitzem l'objecte Usuari glogal
					  actualitza();				   	  
				  }
        	  } catch (Exception e) {
        		  e.printStackTrace();
        		  Alerta.toast(getBaseContext(), "Error saving position");
        	  } 
          }
      });
      
      //Boto findme
      final Button findme = (Button) findViewById(R.id.boto_findme);
      findme.setOnClickListener(new View.OnClickListener() {
    	@Override
		public void onClick(View v) {
    		actualizarPosicion();		
		}
	});
      
      if(usuari.getAutolocation()) {
    	  manual.setChecked(false);
    	  automatico.setChecked(true);
    	  table.setVisibility(table.INVISIBLE);
      } else {
    	  manual.setChecked(true);
    	  automatico.setChecked(false);
    	  table.setVisibility(table.VISIBLE);
      }
      manual.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  manual.setChecked(true);
        	  automatico.setChecked(false);
        	  table.setVisibility(table.VISIBLE);
          }
      });
      automatico.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  manual.setChecked(false);
        	  automatico.setChecked(true);
        	  table.setVisibility(table.INVISIBLE);
        	  //Guardem
        	  try {
        		  guardaAutoLocalitzacio();
        	  } catch (Exception e) {
        		  e.printStackTrace();
        		  Alerta.toast(getBaseContext(), "Error saving autolocation");
        	  } 
          }
      });
      
    }
    
    private void actualizarPosicion()
    {
    	//Obtenemos una referencia al LocationManager
    	locationManager = (LocationManager)getSystemService(Context.LOCATION_SERVICE);
    	
    	//Obtenemos la última posición conocida
    	Location location = 
    		locationManager.getLastKnownLocation(LocationManager.GPS_PROVIDER);
    	
    	//Mostramos la última posición conocida
    	showPosition(location);
    	
    	//Nos registramos para recibir actualizaciones de la posición
    	locationListener = new LocationListener() {
	    	public void onLocationChanged(Location location) {
	    		showPosition(location);
	    	}
	    	public void onProviderDisabled(String provider){
	    		//lblEstado.setText("Provider OFF");
	    	}
	    	public void onProviderEnabled(String provider){
	    		//lblEstado.setText("Provider ON");
	    	}
	    	public void onStatusChanged(String provider, int status, Bundle extras){
	    		Log.i("LocAndroid", "Provider Status: " + status);
	    		//lblEstado.setText("Provider Status: " + status);
	    	}
    	};
    	
    	locationManager.requestLocationUpdates(
    			LocationManager.GPS_PROVIDER, 15000, 0, locationListener);
    }
    
    private void showPosition(Location loc) {
    	if(loc != null)
    	{
    		String l1 = String.valueOf((Double) (loc.getLatitude() * 1E6));
        	String l2 = String.valueOf((Double) (loc.getLongitude() * 1E6));
    		latitud.setText(l1);
    		longitud.setText(l2);
    	} else {
    		longitud.setText("0");
    		latitud.setText("0");
    	}
    }
    
    protected boolean guardaAutoLocalitzacio() throws IOException, XmlPullParserException {
    	String autolocation = "1"; //Localització automàtica		
		try {
			String[][] matriz={{"session_id", ((FindMeApp) this.getApplication()).getSessionId()},{"autolocation", autolocation}};
			JSONObject json = null;
			json = SoapCall.requestJson("updateAutolocation", matriz);
			try {
				if(json.getString("success") != null) {
					Alerta.toast(getBaseContext(), "Saved");
					usuari.setAutolocation(true);
			  	  	((FindMeApp) this.getApplication()).setUsuario(usuari);
					return true;
				} else {
					Alerta.toast(getBaseContext(), "Error saving autolocation : "+json.getString("error"));
				}	
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				Alerta.toast(getBaseContext(), json.getString("error"));
			}
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
    }
    
    protected boolean guardaLocalitzacio() throws IOException, XmlPullParserException {
    	String l1 = longitud.getText().toString().trim();
		String l2 = latitud.getText().toString().trim();
		String autolocation = "0"; //Localització manual
		
		try {
			String[][] matriz={{"session_id", ((FindMeApp) this.getApplication()).getSessionId()},{"longitud", l1},{"latitud", l2},{"autolocation", autolocation}};
			JSONObject json = null;
			json = SoapCall.requestJson("updateLocation", matriz);
			try {
				if(json.getString("success") != null) {
					Alerta.toast(getBaseContext(), "Saved");
					return true;
				} else {
					Alerta.toast(getBaseContext(), "Error saving position : "+json.getString("error"));
				}	
			} catch (JSONException e) {
				// TODO Auto-generated catch block
				Alerta.toast(getBaseContext(), json.getString("error"));
			}
		} catch (JSONException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
    }
    protected void actualitza() {
  	  	usuari.setLatitud(Integer.valueOf(latitud.getText().toString()));
  	  	usuari.setLongitud(Integer.valueOf(longitud.getText().toString()));
  	  	usuari.setAutolocation(false);
  	  	((FindMeApp) this.getApplication()).setUsuario(usuari);
    }
  }