package com.findme;

import java.io.IOException;

import org.json.JSONException;
import org.json.JSONObject;
import org.xmlpull.v1.XmlPullParserException;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.RadioButton;

import com.findme.beans.User;
import com.findme.utils.Alerta;
import com.findme.utils.SHA;
import com.findme.utils.SoapCall;

public class OptionsUser extends FindMeActivity {	
	private static User usuari = null;
	private static EditText name = null;
	private static RadioButton publico = null;
	private static RadioButton privado = null;
	private static EditText oldPass = null;
	private static EditText newPass = null;
	
    @Override
    public void onCreate(Bundle savedInstanceState) {
      super.onCreate(savedInstanceState);        
      setContentView(R.layout.options_tab1);
      
      //Agafem les dades de l'usuari
      usuari = ((FindMeApp) this.getApplication()).getUsuario();
      
      //Plenem les dades de l'usuari
      EditText login = (EditText) findViewById(R.id.idOptLogin);
      login.setText(usuari.getEmail());
      name = (EditText) findViewById(R.id.idOptName);
      name.setText(usuari.getName());
      publico = (RadioButton) findViewById(R.id.idOptRadioPublic);
      privado = (RadioButton) findViewById(R.id.idOptRadioPrivate);
      oldPass = (EditText) findViewById(R.id.idOptOldPass);
      newPass = (EditText) findViewById(R.id.idOptNewPass);
      
      //Boto Save
      final Button save = (Button) findViewById(R.id.boto_save);
      save.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  saveUserData();
          }
      });
      
      if(usuari.getProfile()) {
    	  privado.setChecked(false);
    	  publico.setChecked(true);
      } else {
    	  privado.setChecked(true);
    	  publico.setChecked(false);
      }
      privado.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  privado.setChecked(true);
        	  publico.setChecked(false);
          }
      });
      publico.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  privado.setChecked(false);
        	  publico.setChecked(true);
          }
      });
      
      //Boto Delete Account
      final Button delete = (Button) findViewById(R.id.botro_delete_account);
      delete.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
        	  deleteAccount();
          }
      });
      
      //Boto Cancel
      final Button cancel = (Button) findViewById(R.id.boto_cancel);
      cancel.setOnClickListener(new View.OnClickListener() {
          public void onClick(View v) {
          	//Anem enrere
          	finish();
          }
      });      
    }

	protected void saveUserData() {
		EditText pass = (EditText) findViewById(R.id.idOptOldPass);
		  String current = pass.getText().toString().trim();
		  if(!current.equals("")) {
		  if(usuari.getPassword().equals(SHA.hexDigest(current))) {
			  //Guardem i Actualitzem l'objecte Usuari glogal
			  try {
					guarda();
					actualitza();
					Alerta.toast(getBaseContext(), "Saved");
				} catch (Exception e) {
					//e.printStackTrace();
					Alerta.toast(getBaseContext(), "Error saving");
				} 
		  } else {
			  Alerta.toast(getBaseContext(), "Your current password is wrong");
			  }
		  } else {
			  Alerta.toast(getBaseContext(), "Please, enter your current password to save the changes");
		  }
	}

	protected void deleteAccount() {
		EditText pass = (EditText) findViewById(R.id.idOptOldPass);
		  String current = pass.getText().toString().trim();
		  if(!current.equals("")) {
		  if(usuari.getPassword().equals(SHA.hexDigest(current))) {
			  //Borrem l'usuari
			  try {
				//Borrem el compte
		        	JSONObject json = null;
		      		String[][] matriz={{"session_id", ((FindMeApp) this.getApplication()).getSessionId()},{"user", usuari.getEmail()},{"password", usuari.getPassword()}};
		      		json = SoapCall.requestJson("deleteAccount", matriz);
		      		if(json.getString("success") != null) {
		      			//Sortim de l'aplicació
		      			//int pid = android.os.Process.myPid(); 
		      			//android.os.Process.killProcess(pid);
		      			//finish();
		      			((FindMeApp) this.getApplication()).setSessionId("");
		      			Intent i = new Intent(this, LoginActivity.class);
		      			startActivity(i);
		      		}
					Alerta.toast(getBaseContext(), "User deleted");
				} catch (Exception e) {
					//e.printStackTrace();
					Alerta.toast(getBaseContext(), "Error deleting user");
				} 
		  } else {
			  Alerta.toast(getBaseContext(), "Your current password is wrong");
			  }
		  } else {
			  Alerta.toast(getBaseContext(), "Please, enter your current password to delete your account");
		  }
	}

	protected void actualitza() {
		usuari.setName(name.getText().toString());
  	  	((FindMeApp) this.getApplication()).setUsuario(usuari);
	}

	protected boolean guarda() throws IOException, XmlPullParserException, JSONException {
		String nom = name.getText().toString().trim();
		String newP = newPass.getText().toString().trim();
		String profile = "1";
		if(privado.isChecked()) {
			profile = "0";
		}
		if(((FindMeApp) this.getApplication()).updateUser(nom, profile, newP)) {
			oldPass.setText("");
			newPass.setText("");
			return true;
		}
		return false;
	}	
  }