package com.findme.utils;

import java.io.IOException;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;
import org.ksoap2.SoapEnvelope;
import org.ksoap2.serialization.SoapObject;
import org.ksoap2.serialization.SoapSerializationEnvelope;
import org.ksoap2.transport.HttpTransportSE;
import org.xmlpull.v1.XmlPullParserException;

import android.text.Html;

public class SoapCall {
	private static final String SOAP_ACTION = "urn:findmewsdl#";
	private static final String NAMESPACE = "urn:findmewsdl";
	//private static final String URL = "http://10.0.2.2/findme2/server_nu.php"; //localhost
	private static final String URL = "http://www.noisedrome.com/findme/server_nu.php";
	static SoapSerializationEnvelope envelope = null;
	static SoapObject mainResult = null;
	
	public static JSONObject requestJson(String methodname, String[][] matriz) throws IOException, XmlPullParserException, JSONException {
		SoapObject request = new SoapObject(NAMESPACE, methodname);
		
		String key = null;
		String value = null;
		for(int i=0; i<matriz.length; i++){
			key = matriz[i][0];
            value = matriz[i][1];
            request.addProperty(key, value);
        }

		envelope = new SoapSerializationEnvelope(SoapEnvelope.VER10);
        //envelope.dotNet=true;
        envelope.setOutputSoapObject(request);

        HttpTransportSE androidHttpTransport = new HttpTransportSE(URL);

        androidHttpTransport.call(SOAP_ACTION+methodname, envelope);
        
        String result = envelope.getResponse().toString(); //String normal
        
        result = Html.fromHtml(result).toString();
    	JSONObject json = (JSONObject) new JSONTokener(result).nextValue();
        
        return json;
	}
	
	public static SoapObject requestXml(String methodname, String[][] matriz) throws IOException, XmlPullParserException {
		SoapObject request = new SoapObject(NAMESPACE, methodname);
		
		String key = null;
		String value = null;
		for(int i=0; i<matriz.length; i++){
			key = matriz[i][0];
            value = matriz[i][1];
            request.addProperty(key, value);
        }

		envelope = new SoapSerializationEnvelope(SoapEnvelope.VER10);
        //envelope.dotNet=true;
        envelope.setOutputSoapObject(request);

        HttpTransportSE androidHttpTransport = new HttpTransportSE(URL);

        androidHttpTransport.call(SOAP_ACTION+methodname, envelope);
        
        mainResult=(SoapObject) envelope.getResponse(); 
        
        return mainResult;
	}
	
	public static SoapObject request(String methodname, String[][] matriz) throws IOException, XmlPullParserException {
		return SoapCall.requestXml(methodname, matriz);
	}
	
	public static JSONObject requestSession(String methodname, String session_id) throws IOException, XmlPullParserException, JSONException {
		String[][] matriz={  {"session_id", session_id} };
		return SoapCall.requestJson(methodname, matriz);
	}
}
